---
weight: 4
title: "Apuntes del  Fediverso"
date: 2022-05-01T18:16:57+0200
draft: false
summary: "Apuntes del Fediverso, la red social federada"
categories:
- notes
tags:
- fediverso
- mastodon
---

- [Decentralized Social Media](https://www.fosslife.org/mastodon-basics) from Linux Magazine
- [Traefik v2 and Mastodon, a wonderful couple!](https://www.innoq.com/en/blog/traefik-v2-and-mastodon/) (Innoq version)
- [Github for the article above](https://gist.github.com/smashnet/38cf7c30cb06427bab78ae5ab0fd2ae3)
- [Traefik v2 and Mastodon, a wonderful couple!](http://nicolas.inden.one/article/2020/01/24/traefik-v2-and-mastodon.html) (blog version)
- [An all-in-one Mastodon Image](https://github.com/Wonderfall/docker-mastodon)
- [Hubzilla and Traefik](https://framagit.org/anaqreon/hubzilla-docker)
- [Making your own Mastodon Service in ten steps](https://growyourown.services/making-your-own-mastodon-server-in-10-steps/)
- [Image Descriptions on the Fediverse](https://m0yng.uk/Image-descriptions-on-the-Fediverse/)
- [A Hitchhiker's Guide to the Fediverse](https://gofoss.net/fediverse/)
- [Fossllife: Mastodón Basics](https://www.fosslife.org/mastodon-basics)
- [Mastodon Docker Setup with Traeffic via php scripts](https://gitlab.com/dweipert.de/devops/mastodon-docker-traefik)
- [Feditips](https://mstdn.social/@feditips/108215973331591896) (mastodon account)
- [Migadu](https://www.migadu.com/index.html) Email service for Domains
- [Fediverse Party](https://fediverse.party/)
- [Comunidades Fediversales en Español](https://notas.niboe.info/s/6lr2U2myb#)
- [Fedi-Directory](https://fedi.directory/) la colección de @FediFollows

## ¿Qué es el Fediverso?

El origen del Fediverso puede situarse en proyectos como ___Diaspora___ o ___Identi.ca___, los primeros intentos de crear un red social descentralizada. Con el tiempo evolucionaron, el creador de de _Identi.ca_ Evan Prodromou desarrolló _pump.io_, un _framework_ que permitía a los desarrolladores construir servicios de redes sociales.

Con el tiempo el [W3C]^(World Wide Web Consortium) vio las ventajas de _pump.io_ y tomándolo como base publicó la especificación y recomendación ___ActivityPub___.

Y sobre _ActivityPub_ nació el __Fediverso__.

_ActivityPub_ es un protocolo y una API que permite a los servicios definidos con ella la comunicación a través del Fediverso con otros nodos tanto del mismo servicio como de otros servicios diferentes. Por ejemplo,  puedes publicar una foto en tu cuenta de ___Pixelfed___ (un servicio para compartir fotos) y hacer que esa foto aparezca en las lineas temporales de la gente que te siga en Mastodon, el servicio de microblogging que es quizás el buque insignia del Fediverso.

El Fediverso no solo comparte publicaciones, los nodos son capaces de compartir recursos entre ellos e incluso a través de técnicas P2P entre clientes. Por ejemplo si publicas un video en una instancia de ___PeerTube___ (puede que en tu propio servidor) Necesitarás bastante ancho de banda pero menos del que crees, los clientes que estén viendo el mismo video compartirán la carga.

Además de ___Mastodon___, ___Peertube___ y ___Pixelfed___, podríamos citar una plataforma para compartir audio dirigida a músicos y podcasters llamada ___Funkwhale___. También podríamos hablar de  ___Hubzilla___ que se autodefine como "una potente plataforma para crear sitios web interconectados que ofrecen identidad descentralizada, comunicaciones y una infraestructura de permisos, todo ello basado en tecnología común de servidores web.", de ___Akhoma___,  ___Misckey__ o ___Calckey___ para microblogging, de ___Bookwyrm___ para hablar de libros, etc. etc. etc.

En resumidas cuentas, el __Fediverso__ es una red Federada, compuesta de muchas redes sociales interconectadas. El número de usuarios total según la estimación más reciente ronda los cuatro millones de personas.

__Descentralizado__

: En vez de un único proveedor de servicios hay multitud de proveedores que ofrecen acceso al __Fediverso__. Cualquiera puede configurar un servidor (normalmente denominados instancias) ya sea para uso personal o para dar servicio a una comunidad

__Federada__

: Los servidores de distintos servicios se comunican entre si mediante el protocolo ___ActitityPub___

__No comercial__

: Aquí los usuarios no son el producto, el __Fediverso__ no está diseñado para cautivar la atención del usuario o mantenerlo enganchado a la red

__Neutral__

: No hay filtros para priorizar o recomendarte contenido. Los contenidos se muestran en orden cronológico. Los filtros los establece el usuario

### Cosas en el Fediverso

Mastodon
: Microblogs
: [Listado de instancias](https://joinmastodon.org/) Hay muchas instancias de Mastodon para escoger

Pixelfed
: Compartir tus fotos.
: - <https://pixelfed.org/>
: - [Instancia principal](https://pixelfed.social/)

PeerTube
: Red federada para compartir videos
: - <https://joinpeertube.org/>
: - <https://tilvids.com/videos/overview>
: [Sepia Search](https://search.joinpeertube.org/)

BookWrym
: Red social federada para compartir tus lecturas, hablar de libros, escribir reseñas y descubrir que es lo siguiente que vas a leer.
: - <https://joinbookwyrm.com/>
: - <https://bookwyrm.social/>

Funkwhale
: Una red social para compartir y escuchar música
: [Get started](https://funkwhale.audio/#get-started)
: [Instance List](https://network.funkwhale.audio/dashboards/d/overview/funkwhale-network-overview?orgId=1&refresh=2h)

Friendica
: Es una plataforma de comunicaciones descentralizada que puede conectarse con plataformas independientes como el Fediverso o Diaspora o comerciales como Twitter.

Lemmy
: Una plataforma libre y descentralizada de compartición y discusión de enlaces.

Pleroma
: Otra plataforma de microblogging

Misskey
: Otra plaforma más de microblogging

Goldfish
: Parecido a TikTok

Gotosocial
: Microblogging facílisimo de autoalojar en docker.

## ¿Qué es Mastodon?

__Mastodon__ es un servicio de microblogging que ahora mismo parece ser el servicio más conocido del __Fediverso__.

__Mastodon__ puede parecerse mucho a Twiter, pero la verdad es que son muy diferentes no te confundas.

Para empezar __en Mastodon no hay un algoritmo__ para recomendar contenidos (y mantenerte pegado a la pantalla de tu dispositivo). Normalmente si acabas de llegar a la red te parecerá todo muy silencioso y no hay mecanismos automáticos para que deje de serlo.

Aquí eres tú quien tiene que buscar y seguir a gente interesante. Es importante cuidar tu linea de tiempo __local__ (el conjunto de gente que sigues) para tener una experiencia de calidad (hay muchas herramientas para el ajuste fino).

Para empezar puedes buscar algún _hastag_ interesante y descubrirás seguramente gente para seguir. Una vez que sigas a alguien puedes cotillear a quien sigue, para descubrir a mas gente. No hay que tener miedo de seguir gente, y más importante, no dudes en dejar de seguirlos si no te gusta lo que publican. Hay soluciones "más ligeras", puedes silenciar temporalmente una cuenta que se enrolla hablando de algo que no te interesa. Y también hay soluciones más drásticas, puedes silenciar o bloquear a cuentas que te resulten ofensivas e incluso silenciar o bloquear servidores enteros.

Como resultado de esta forma de funcionar, el número de gente que te siga es bastante irrelevante, de hecho el interfaz puede configurarse para ocultartelo a ti mismo. Lo mismo ocurre con los favoritos que obtenga una publicación (sólo los ve el autor). Y ninguna de esas métricas influye en el alcance de tus publicaciones. La información se difunde exclusivamente por _reblogs_ de gente que te lea y de la gente que lea a tus seguidores.

Si tienes mucho interes en acrecentar tu audiencia usa los _hashtags_ prolífica y cuidadosamente.

Sigue gente y _hastag_ que te gusten. Además puedes activar la alerta en la gente que sea importante para ti.

Organiza a la gente que te sigue en listas para facilitar la lectura.

Siempre puedes seguir via RSS a la gente (y hastags) que quieras.

Escoge un interfaz de usuario lo más avanzado posible, la experiencia será muy diferente con el interfaz adecuado.

__Sigue siempre al administrador de tu instancia__, salvo que sea muy brasas considera la posibilidad de activar la campana. Hay que estar atento tanto a sus avisos como a sus peticiones de ayuda.

### Detalles

* Cuando quieres difundir el _toot_ (un _post_) de alguna cuenta que sigues lo único que puedes hacer es un _boost_ (_reblog_), los favoritos y los marcadores (_bookmarks_) son cosas privadas en Mastodon (y en el Fediverso en general)
* Los favoritos se usan para mostrar reconocimiento, aprecio o acuerdo con un _toot_ (escoge como quieres interpretarlos), quedan almacenados en tu perfil para que puedas visitarlos en el futuro.
* Un _bookmark_ es estrictamente privado, el autor del _toot_ no sabrá que te lo has apuntado.
* El _boost_ se usa para difundir lo que sea, animar el diálogo o compartir cosas que te gustan.
* Los _hastag_ son importantes, se usan en búsquedas y además la gente puede seguir _hastags_
* Si publicas en varios idiomas asegúrate de configurar correctamente el idioma de cada publicación. Es muy importante para que la gente pueda filtrar y ver solo las publicaciones que pueda leer.

### Recetas Mastodónticas

Mastodon provee varias herramientas para la gestión de tu linea temporal.

* Puedes añadir notas a cualquier perfil. P.ej. para recordar por qué empezaste a seguirlo, si es un perfil ofensivo, cualquier cosa que quieras recordar
* Puedes deshabilitar los _boost_ usuario a usuario. Podrías querer ver los post de un usuario pero no todo lo que le interese.
* Puedes silenciar (_"mutear"_) temporalmente una cuenta
* Puedes filtrar post por palabras específicas, _hashtags_ o frases
* Y como última medida puedes Bloquear, dejar de seguir o silenciar definitivamente.
* Todas las cuentas de Mastodon tienen RSS, puedes suscribirte por ejemplo a mastodon.technology/comacero.rss
* Modula el alcance de tus _post_, mira si quieres que sean públicos, sólo para seguidores, sólo para mencionados, no-listados, etc. etc.

#### Verificación de la cuenta

Mastodon tiene un mecanismo de verificación. Necesitas tener un sitio web en el que seas conocido.

Enlaza tu perfil en Mastodon desde el sitio web. Puede ser un enlace visible o una etiqueta de enlace en la cabecera del html con un atributo `rel=me`.

Enlaza la página web desde tu perfil de Mastodon. Deberías ver que aparece una marca verde de verificación en el perfil.

#### Usa _hashtags_

Las busquedas en Mastodon funcionan sobre _hashtags_, además con las versiones más modernas de Mastodon puedes seguir _hashtags_. Es importante poner los _hashtags_ al final de tu _post_ y usar notación _CamelCase_. Las dos recomendaciones son para que las aplicaciones de accesibilidad (texto a voz por ejemplo) funcionen correctamente.

#### Usa _alt-text_ en la imágenes

Mastodon nació como una red inclusiva, usa _alt-text_ en todas las imágenes para hacerlas accesibles a todo el mundo.

#### Usa listas

Si tienes intereses muy variados o perteneces a varias comunidades distintas las listas te permiten mantener a toda la gente que sigues ordenada y facilitan mucho la lectura. Puedes asignar a cualquier persona que sigas a una o varias listas.

#### Threads o listas encadenadas de posts

Asegúrate de poner en "publico" solo el post cabecera y el resto en "unlisted" para mantener la linea temporal limpia.

#### Usa filtros

Aun lo estoy estudiando, pero son muy útiles.

<!--

Use Fedifinder to follow all the accounts you followed on Twitter, and sync up your follow and block lists.

Avail yourself of the multiple public lists of hundreds of journalist accounts on Mastodon.

-->

#### Misc

Quizá estás aterrizando en #Mastodon o quizás, ya llevas un ratito por aquí, pero un detalle importante a tener en cuenta es:

‼️No compartir en otros sitios web o redes sociales enlaces a contenidos publicados originalmente en Mastodon sin el consentimiento de sus autores.‼️

‼️En #Mastodon las búsquedas por palabras clave sólo devuelve resultados de contenidos publicados por el propio usuario, incluyendo sus etiquetas, artículos que ha marcado como favoritos, los que ha reenviado o aquellos en los que ha sido mencionado.‼️

‼️La función de citar inevitablemente agrega toxicidad a los comportamientos de las personas. Estás tentado a citar cuando deberías estar respondiendo, por lo que hablas a tu audiencia en lugar de a la persona con la que estás hablando. Se vuelve performativo. Incluso cuando lo haces por "bien", como ridiculizar comentarios horribles, estás dando más atención a los comentarios horribles...‼️



## Calckey

Su instancia tiene 5 diferentes líneas de tiempo habilitadas

    La línea de tiempo Inicio es donde puedes ver las publicaciones de tus seguidores.
    La línea de tiempo Local es donde puedes ver las publicaciones de todos los demás en esta instancia.
    La línea de tiempo recomendada es donde puedes ver las publicaciones de las instancias que los administradores recomiendan.
    La línea de tiempo Social es donde puedes ver las publicaciones de los amigos de tus seguidores.
    La línea de tiempo Global es donde puedes ver las publicaciones de todas las demás instancias conectadas.

### Configuración

- Activar la opción de _Show local post in **Social Timeline**_


### Varios

- Cuando Calckey dice que no puede cargar un medio se pueden cargar desde el servidor remoto.
