---
weight: 4
title: "Apuntes de Autonomía Digital"
date: 2022-03-29T18:54:41+0200
draft: true
summary: "Más valdría hablar de guerrilla digital"
categories:
  - notes
tags:
  - soberania digital
---


{{< admonition type=warning title="Work in progress" open=true >}}

No está completo.

{{< /admonition >}}

## ¿Qué es la Autonomía Digital?

Últimamente se habla mucho de Soberanía Digital y de servicios auto alojados (o _self hosted_). Yo dejaría el término _Soberanía Digital_ para cuestiones que afectan a las naciones o a la Unión Europea en nuestro caso, por que los medios necesarios para alcanzar la Soberanía Digital tendrán que ser transnacionales para hacer frente a las potencias en juego, ya hablemos de paises como China, USA o Rusia, o a empresas como Google, Facebook, Amazon, Microsoft, etc.

A nivel de individuo, creo que el término _Autonomía Digital_ sería más ajustado.

Por otro lado, me temo que igual que la Soberanía Digital exige medios a nivel Europeo (como poco), la Autonomía Digital también exige esfuerzos que no están al alcance de todos. Cuanto más aprendo de este tema más convencido estoy que debería organizarse mediante la cooperación de varias personas, seguramente mediante una comunidad de intereses comunes, ya sea una asociación, una cooperativa o la forma que se le quiera dar. Creo que la Autonomía Digital es de interés para cualquiera, pero ciertamente no todos tendrán conocimientos suficientes para implementarla por su cuenta. Un ejemplo de comunidad organizada para procurarse la autonomía digital es [Disroot](https://disroot.org), no he buscado mucho así que es de suponer que habrá más.

Añadir definición de autonomía digital

## ¿Por qué?

Detallar razones. Todo el mundo cita la privacidad como la primera razón para implementar estos servicios de modo auto-alojado.

## ¿Cómo lo hacemos?

Vamos a describir como implementaremos nuestro plan de autonomía.

### Arquitectura: la infraestructura

En mi caso tengo:

**Dominio propio con su DNS Zone**

: Contratado con un proveedor de internet reconocido.


- Correo electrónico subcontratado a un proveeder de buena reputación y que nos permita usar nuestro propio dominio.
- VPS
- Servicio de almacenamiento local en casa

### Servicios deseados

#### Almacenamiento

Para que queremos

## Implementación

### Dominio propio

### Correo electrónico

### Almacenamiento

## Cifrando con gocryptfs sobre cualquier nube

1. Actualizamos a la última versión de Go (golang)
1. Clonamos el repo de `gocryptfs` con

    ```bash
    git clone https://github.com/rfjakob/gocryptfs.git
    cd gocryptfs
    ./build-without-openssl.bash

    cp ./gocryptfs ~/.local/bin/
    ```

1. Creamos dos directorios: uno para almacenar el contenido cifrado y otro como punto de montaje:

    ```bash
    md ~/Documents/cloud/.cripta
    md ~/mnt/cripta
    ```

1. Iniciamos el sistema de ficheros cifrado, y lo montamos

    ```bash
    gocryptfs --init ~/Documents/cloud/.cripta
    gocryptfs ~/Documents/cloud/.cripta ~/mnt/cripta
    ```

    Al iniciar el sistema de ficheros cifrado hay que guardar la keyphrase en un lugar seguro.

En el sistema de ficheros cifrado hay un fichero .conf que no debemos compartir en la nube.

El sistema de ficheros cifrado tiene varias debilidades (listar)

## Cifrando con `cryfs` sobre cualquier nube

Este sistema de cifrado parece más seguro que gocryptfs, no permite conocer la estructura de los directorios y siempre que no estemos haciendo ediciones simultaneas debería ser seguro durante la sincronización con la nube.

Se instala con `apt install cryfs` en mi caso tengo la versión 0.10.2.

El uso en principio es trivial:

```bash
cryfs <directorioCifrado> <directorioClaro>
```

Para hacerlo más seguro:

`cryfs --config ~/asegurado/cryDrop.config ~/Dropbox/directorioCifrado ~/mnt/directorioClaro`



## Referencias

- <https://github.com/awesome-selfhosted/awesome-selfhosted>
- <https://www.rosehosting.com/blog/self-hosted-alternatives/>
- <https://selfhosted.show/> No se que es esto
- [Veracrypt](https://veracrypt.fr/en/Downloads.html)
- [fscrypt](https://github.com/google/fscrypt)
- [ecryptfs](https://www.ecryptfs.org/)
- [gocryptfs](https://nuetzlich.net/gocryptfs/)
- [cryfs](https://www.cryfs.org/)
- <https://www.addictivetips.com/ubuntu-linux-tips/best-linux-encryption-tools/>

### Servicios en la red

- [disroot](https://disroot.org)
- [monocles](https://monocles.de/)

## Cursos en la Domus

### Primer curso el dia 10 de marzo de 2023

- Taller de iniciación a la seguridad digital.
- conceptos básicos de seguridad hash, password segura
- fortaleza de contraseñas
- gestor de contraseñas
- mas nociones generales
