---
weight: 4
title: "Apuntes de Mapas Textiles"
date: 2023-03-29T17:26:48+0200
draft: false
hiddenFromHomePage: true
summary: "Apuntes del curso de Mapas Textiles de Rosario Belda"
categories:
- notes
tags:
- textil
---

## Mapa de estrellas

Desde el principio consideramos proyectos que nos dejaran abierta la posibilidad de incluir fuentes de luz. Así que pensamos en un mapa de los Faros de Galicia o un mapa estelar. Decidimos hacer un mapa de estrellas.

## Fuentes de Mapas Celestes

- [Mag-7 Star Atlas](https://www.siaris.net/astro/atlas/), disponible para descarga en [Internet archive](https://archive.org/details/Mag_7_Star_Atlas), un hermoso mapa a todo color en un tamaño muy manejable. (Siempre llevo una copia en el coche) Compilado por Andrew L. Jonhson.
- [The Beginners Star Atlas](https://vazhorov.wordpress.com/2020/09/03/beginners-star-atlas-v2/) Otro mapa compacto a todo color, obra de Ed Vazhorov. La página está en ruso, pero el artículo para descargar el mapa está en inglés.
- [The Night Sky Maps](https://www.olle-eriksson.com/night-sky-maps/information.html) PDF de descarga gratuita, un mapa genial (tres mapas en realidad) compilado por el astrónomo aficionado Olle Eriksson.
- [Deep Sky Hunter Atlas](https://www.deepskywatch.com/deep-sky-hunter-atlas.html) PDF de descarga gratuita.
- [Tri-Atlas](https://www.deepskywatch.com/deep-sky-hunter-atlas.html) El famoso mapa estelar Tri-Atlas de José R. Torres y Casey Skelton
- [Taki’s 8.5 Magnitude Star Atlas](https://allans-stuff.com/takis-8-5-magnitude-star-atlas/) Enlazo al mirror por que la página original de Toshimi Taki parece un poco abandonada.
- [Stellarium] y su [versión web](https://stellarium-web.org/)
- [Skymap Online](https://www.skymaponline.net/)
- [Mapa Interactivo de Sky&Telescope](https://skyandtelescope.org/interactive-sky-chart/)


## Etapas del proyecto

### Mapa base

Decidimos bajarnos el mapa desde el mapa interactivo de Sky&Telescope. Como queremos una proyección con Polaris en el centro del mapa, tenemos que fijar nuestra localización en algún punto del ecuador, es decir a 90 grados de latitud, la longitud nos da igual.

Jugando con el tiempo podemos girar nuestro mapa. Aunque probablemente no influya en el resultado final hemos girado el mapa para que Orión nos quede a las tres en el hemisferio norte. Seguramente en el resultado final uniremos los dos hemisferios por la constelación de Orión (que nos gusta mucho).

### Limpiar el mapa con Inkscape

### Imprimir el mapa sobre tela

### Bordando el mapa





## Referencias generales del curso

- [Mapas de palos de polinesia](https://www.vistaalmar.es/ciencia-tecnologia/historia/5565-los-mapas-de-palos-para-la-navegacion-en-las-islas-marshall.html)
- [Mapas de las novelas de Verne](http://verne.garmtdevries.nl/en/maps/originals.html)
- [Deformación en las proyecciones de una cabeza humana](https://recuerdosdepandora.com/geografia-2/una-cabeza-para-mostrar-como-los-mapas-distorsionan-la-realidad/)
- [Mapas Milhaud](https://mapasmilhaud.com/)
- [Recuerdos de Pandora](https://recuerdosdepandora.com/geografia-2/una-cabeza-para-mostrar-como-los-mapas-distorsionan-la-realidad/) el blog de Mapas Milhaud
- [Mola](https://youtu.be/sA_ats3TwT0)
- [Biblioteca del Congreso de EEUU](https://www.loc.gov/collections/world-digital-library/about-this-collection/)
- [Blog de Maxar Technologies](https://blog.maxar.com/) Una empresa de imágenes satelitales
- [ESRI Map Gallery](https://mapgallery.esri.com/)
- [ArcGIS](https://www.arcgis.com/home/webmap/viewer.html)
- [spaM de Madalena Parreira](https://madalenaparreira.com/SPAM)

### Artistas

- [Arounna Khounnoraj](https://www.instagram.com/reel/CkYWVApNW3X/?igshid=MDJmNzVkMjY=)
- [Agnes Hansella](https://agneshansella.com/id/article/oops-loops)
- Rieko Koga
  - [Instagram](https://www.instagram.com/riekokoga/)
  - [Entrevista en ArteMorbida](https://www.artemorbida.com/interview-with-rieko-koga/?lang=en)
- Paula Kovarik
  - [Página personal](https://www.paulakovarik.com/)
  - [Instagram](https://www.instagram.com/yellowbrickstudio/)
- Mirjam Gielen (Mirjam Textiles)
  - [Instagram](https://www.instagram.com/mirjamtextiles/)
  - [Facebook](https://www.facebook.com/mirjamtextiles/)
- Louise Watson
  - [Página personal](https://louisemaywatson.blogspot.com/2019/03/threads-by-mirjam-gielen.html)


## Herramientas libres

### cstich

### colores

#### online

- [w3schools colour course](https://www.w3schools.com/colors/default.asp) Un curso muy completo de colores
- [htmlcolorcodes](https://htmlcolorcodes.com/color-picker/) Esta tiene bastante teoría del color, explica por encima los distintos tipos de armonía.
- [colr.org](https://www.colr.org/) Bastante pobre, es para hacer paletas a partir de imágenes.
- [Colorpicker](https://colorpicker.me/) Esta está bien, sólo hace lo justo, escoges un color y te sacas las armonías.
- [Colormind](http://colormind.io/) Se supone que usa Deeplearning para sacar las paletas de colores, no hace mucho más.

#### herramientas

- Gpick
- [delicolour](https://github.com/eepp/delicolour)
