---
weight: 4
title: "Apuntes de Sintetizadores DIY"
date: 2022-07-29T13:53:56+0200
draft: false
math: true
summary: "Apuntes de Sintetizadores"
categories:
- notes
tags:
- electrónica
---

## Conceptos

VCO

: _Voltage Controlled Oscillator_, un oscilador controlado por tensión.


<!--
https://easyeda.com/editor#id=9867176af11f49c48e609c6f65c8fcef
http://musicfromouterspace.com/index.php?MAINTAB=SYNTHDIY&VPW=1910&VPH=779
https://www.cuidevices.com/blog/understanding-audio-jack-switches-and-schematics
videos de something go wrong

Their spec's are completely different:
1) The lousy old LM358 works from a supply as low as 3.0V but the NE5532 needs a minimum of 6.0V.
2) The LM358 has inputs that work at 0V and an output that goes very close to 0V, but the NE5532 has inputs that do not work when they go below 3V and has an output that goes down to only 1.5V.
3) The LM358 has negative input bias current but the NE5532 has positive input bias current.
4) The LM358 has open inputs but the NE5532 has diodes across the inputs.
5) The LM358 has poor high frequency response but the NE5532 has excellent high frequency response.
6) The LM358 has a lot of noise and distortion (to make fuzz?) but the NE5532 has low noise and has very low distortion.

vco en hackaday -> https://hackaday.io/project/174364-synth-vco
vco en DIY Analog Synthesizer https://invidious.sethforprivacy.com/watch?v=SE9ZtG0E58g
moritz klein -> https://invidious.sethforprivacy.com/watch?v=3tMGNI--ofU
moritz klein -> https://invidious.sethforprivacy.com/watch?v=QBatvo8bCa4
birth of a synth -> https://www.birthofasynth.com/Thomas_Henry/Pages/VCO-1.html
-->



Es una de las fuentes de sonido en el sintetizador. El oscilador controlado por tensión (**V**oltage  **C**ontroled **O**scillator) puede producir diferentes formas de onda simples o complejas.

Algunos VCO permiten seleccionar el tipo de onda de salida, otros  generan diferentes tipos de onda de salida simultanemente, y las ofrecen en sendas tomas de salida.

Los VCO tienen una entrada CV (**C**ontrol **V**oltage Input) que permite controlar la frecuencia de la nota producida (de ahí su nombre). La señal CV puede venir de cualquier fuente. Podemos usar un controlador de teclado que genere los voltajes correspondientes a notas de la escala, pero también podemos obtener los voltajes de control de cualquier fuente que se nos ocurra: de un sensor, de una fuente aleatoria, etc. etc.

Para usar un VCO para generar notas musicales tenemos varios estándares establecidos:

**Voltios por octava**

:    Cada voltio equivale a una octava. Propuesto por Moog en la década de los 60. Este es el estándar mejor implantado hoy en dia y casi todos los sintetizadores lo usan.

**Hertzios por octava**

:    Subir una octava equivale a doblar el voltaje de control y bajar una octava equivale a reducirlo a la mitad. Un estándar muy utilizado en Yamaha y Korg.

Además de la entrada VC, el VCO puede tener más entradas.


LFO

: _Low Frequency Oscillator_



## Proyectos

### Atari Punk Console

El Atari Punk Console (APC) es uno de los proyectos recomendados para los principiantes ya que es muy fácil de hacer, pero el sonido no es muy melodioso que digamos. El nombre original era "Sintetizador de Sonido" ([Forrest M. Mims III - 1984](http://www.forrestmims.org/)). Mas tarde el grupo Kaustic Machines (la única referencia que encontré es [esta](https://compiler.kaustic.net/machines/back.html), y por si acaso me he salvado todos los esquemas que hay en la página), le puso el nombre de Atari Punk Console por que el sonido que produce se parece al de las primeras consolas Atari.

#### IC555 (Circuito integrado)

El montaje de la APC está basado en el uso de [NE555](https://es.wikipedia.org/wiki/Circuito_integrado_555) posiblemente uno de los chips más versátiles de la historia de la electrónica.

En principio el circuito divide la tensión Vcc en tres partes iguales gracias a su divisor de tensión con tres resistencias de 5K (lo de que se llama 555 por estas tres resistencias es una leyenda desmentida por su creador)

- _Vcc_ y _GND_ son los pines de alimentación. El voltaje de alimentación típico va de 4.5 V hasta los 16 V
- _Output_ (pin 3), aquí tenemos la salida del integrado, la salida alta es tipicamente: $V_{cc} - 1.7 V$, la salida baja
- _Trigger_ (pin 2) cuando en la entrada _Trigger_ tenemos una tensión menor de 1/3 de Vcc, el integrado  activa la salida (y yo diria que pone la pata _Discharge_ en alta impedancia)
- _Threshold_ (pin 6), cuando la tensión en la entrada _Threshold_ es mayor que 2/3 de Vcc, el integrado desactiva la salida, y ademas pone el terminal _Discharge_ (pin 7) a tierra (GND)
- _Reset_ (pin 4), Si ponemos _RST_ a un voltaje cercano a cero (por debajo de 0.7 V) pone la salida del circuito a nivel bajo. En caso de no usar esta patilla lo mejor es conectarla a _Vcc_ para evitar reseteos indeseados.
- _CV_ (pin 5) es el pin de control de voltaje, el voltaje aplicado a esta patilla puede variar entre $V_{cc} - 1.7 V$ hasta prácticamente cero, este voltaje nos permitiría alterar los tiempos que definen los pulsos de salida o incluso conseguir salidas en rampa.

##### Configuración astable (no estable) del 555

Esta configuración no presenta un estado estable, tendremos un pulso cuadrado a la salida.

Es una configuración que podemos distinguir fácilmente por las dos resistencias en serie con un condensador y por que los pines _Threshold_ y _Trigger_ están conectados.
Los pines de _Reset_ y _Control Voltage_ no se usan, por eso conectamos la patilla _Reset_ a $V_{cc}$ y la patilla _CV_ a tierra a través del condensador C2.

{{< figure src="/images/synthes/ne555_astable.jpg" title="ne555 aestable" width=500 >}}

- En el momento en que alimentamos el circuito el condensador C1 comienza a cargarse con la corriente que pasa a través $R_1 + R_2$
Mientras el voltaje sea pequeño ($V_{c1} < \frac{1}{3}V_{cc}$) al estar el _Trigger_ por debajo del umbral la salida del circuito estará alta.

- Cuando el voltaje en el condensador C1 iguale o supere $\frac{2}{3}V_{cc}$, al estar _Threshold_ por encima de su umbral, la salida pasará a valor bajo. El pin _Discharge_ se pondrá a tierra, y el condensador C1 empezará a descargarse a través de $R_2$

- Cuando el condensador $C_1$ se descargue hasta $\frac{1}{3}V_{cc}$ de nuevo se activará la entrada _Trigger_ que hará que la salida pase a nivel alto y _Discharge_ pase a estado de alta impedancia.

Y todo el ciclo se repite de nuevo.

##### Configuración monoestable del 555

{{< figure src="/images/synthes/ne555_monostable.jpg" title="ne555 monoestable" width=500 >}}

##### Configuración biestable del 555
<!-- https://angelmicelti.github.io/4ESO/EAN/el_555_como_biestable.html -->

- [Un modelo simple](https://samvssound.com/projects/synthesizers/atari-punk-console/)
- [El mismo modelo con LFO](https://samvssound.com/tag/stepped-tone-generator/)
- <https://sdiy.info/wiki/Atari_Punk_Console>
- <https://compiler.kaustic.net/machines/apc.html>
- <https://www.jameco.com/Jameco/workshop/diy/atari-punk-console.html>
- <https://github.com/wenbakefield/bent-wavefield>

### Baby 8 Sequencer (B8BY)

- [Oh Baby, Baby10 – Build A Classic Analog Music Sequencer](https://hackaday.com/2016/01/14/oh-baby-baby10-build-a-classic-analog-music-sequencer/)
- [Eddy Bergman.com: Synthesizer Build Part 8: 8 step sequencer](https://www.eddybergman.com/2019/12/synthesizer-build-part-8-8-step.html)
- [Hackster.io B8BY](https://www.hackster.io/Jettsette/b8by-baby-8-step-sequencer-c5d055)
- [Atary Punk Console & B8BY](https://www.instructables.com/Atari-Punk-Console-With-a-Baby-8-Step-Sequencer/)
- [Baby 5 sequencer – Moritz Klein inspired version](https://knopslmodular.design.blog/2022/04/27/baby-5-sequencer-moritz-klein-inspired-version/)
- [Atari Punk Console & Sequencer](http://owyheesound.com/sequencer.php)
- <https://github.com/wenbakefield/bent-wavefield>

### Altavoz

- https://samvssound.com/projects/amplifiers/lm386-power-amplifier/

### Velleman voice changer

- https://diyaudiocircuits.com/velleman-mk171-voice-changer-circuit/

### Weird Sound Generator

### Noise Toaster

### Construir un eurorack

* Construir un Eurorack en cinco videos: [Youtube](https://youtu.be/EjDTz8JsX6c) o [Invideous](https://invidious.slipfox.xyz/watch?v=EjDTz8JsX6c)
* <https://youtu.be/AFhHArHk5JE>
* [Construcción de un Eurorack I](https://invidio.xamh.de/watch?v=6mVbi8B3usY)
* [Construcción de un Eurorack II](https://invidio.xamh.de/watch?v=NLljeZpyGEY)
* [Z-rails A](https://www.gear4music.es/es/Grabacion-y-Ordenadores/Tiptop-Audio-Z-Rail-40HP-Pair-Silver/218F)
* [Z-rails Thomann](https://www.thomann.de/es/tiptop_audio_z_rails_84hp_silver.htm)
* [Tienda en Holanda](https://www.etsy.com/shop/ModularSynthLab?ref=l2-about-shopname)

### Sintes digitales

#### TeensyPoly6

- [TeensyPoly6 en github](https://github.com/albnys/TeensyPoly6)
- [Video del TeensyPoly6](https://invidious.esmailelbob.xyz/watch?v=Exk_K2VwGu0)
- [Tsynth](http://electrotechnique.cc/) Basado en Teensy 4.1 no parece lo mismo

#### Polykit
- [Github del proyecto](https://github.com/polykit)
- <https://www.youtube.com/shorts/rFO4J-EEk-8>
- [Github de Crayg Barnes](https://github.com/craigyjp) Hace variantes del Polykit

#### Bomtempi
- <https://youtu.be/MxDHKpysxYs>
- <https://github.com/floretan/bontempi/tree/master/synth_main>

#### FPGA
- <https://thetinysynth.wordpress.com/technical-details/>



## Referencias

- [Sam vs Sound](https://samvssound.com/)
- [Sam vs Sound: Atari Punk Console](http://samvssound.com/projects/synthesizers/atari-punk-console/)
- [Atari Punk Console Improved](https://samvssound.com/tag/stepped-tone-generator/)
- [Synth DIY Wiki](https://sdiy.info/wiki/Main_Page), parece muy centrada en el [CatGirlSynth](https://sdiy.info/wiki/CatGirl_Synth#The_CGS_modules), una colección de módulos publicada como CC-BY-SHA-NC. La [página original de CGS](https://web.archive.org/web/20070202151335/http://cgs.synth.net/) se ha archivado en _archive.org_
- [Music From Outer Space](http://musicfromouterspace.com/) Probablemente una de las más conocidas, es la página del autor del libro _Make: Analog Synthesizers_
- [Music From Outer Space: Projects](http://musicfromouterspace.com/index.php?MAINTAB=SYNTHDIY&PROJARG=ALIENSCREAMER%2FALIENSCREAMER.php&CATPARTNO=ALIENSCREAMERPCB)
- [MFOS: Weird Sound Generator](http://musicfromouterspace.com/index.php?CATPARTNO=WSG001&PROJARG=WSG2010%2Fwsg_page1.html&MAINTAB=SYNTHDIY&SONGID=NONE&VPW=1910&VPH=807) El proyecto que recomiendan en MFOS para empezar.
- [Especificaciones Eurorack](https://sdiy.info/wiki/Eurorack) (Esta wiki parece abandonada)
- [Eurorack](https://intellijel.com/support/eurorack-101/) Bastante bien explicado
- [www.synth.net](https://web.archive.org/web/20070702154444/http://www.synth.net/) preservada en _archive.org_. En su dia se autodefinían como el _Recurso Definitivo para Sintetizadores_, alojaba varios proyectos diferentes.
- [Minimo](https://minimosynth.com/)
- [OTTO](https://github.com/bitfieldaudio/OTTO) un sintetizador open hardware inspirado en el OP-1 (sea lo que sea OP-1)
- [Una lista de synth abiertos](https://www.synthtopia.com/content/tag/open-hardware/)
- [The Synthesizer Academy](https://synthesizeracademy.com/)

### Videos

- [Building a DIY Kit](https://www.youtube.com/watch?v=cduc68TVWJ4) Un canal bastante interesante
- [DIY Minimoog Clone](https://www.youtube.com/watch?v=PATlf0W3m7k) REVISAR
- [Getting Started with Modular Synths](https://www.youtube.com/watch?v=AFhHArHk5JE) Como contruir un Eurorack
- <https://m.youtube.com/watch?v=Exk_K2VwGu0>


### Para revisar

- <https://hackaday.com/2015/02/04/logic-noise-sweet-sweet-oscillator-sounds/>
- <https://www.schmitzbits.de/>
- <https://www.soundtronics.co.uk/mfos-sound-lab-mini-synth-mkii-diy-electronics-parts-kit.html>
- <https://www.soundtronics.co.uk/mfos-synth-diy-build-knowledge-base/diy-mfos-voltage-controlled-oscillator-kb.html>
- <https://blog.thea.codes/the-design-of-the-juno-dco/>
- <https://synthityourself.com/>
- <https://www.thegeekpub.com/272691/building-a-breadboard-synthesizer-with-a-raspberry-pi-and-an-arduino-uno/>
- <https://northcoastsynthesis.com/synth-diy-projects/>
- <https://www.hongkiat.com/blog/open-source-hardware-synths/>
- <https://diyaudiocircuits.com/velleman-mk171-voice-changer-circuit/>
- [modwiggler](https://www.modwiggler.com/forum/index.php) un foro centrado en el tema de sintetizadores
- [Schemas for Minimoog](https://sites.google.com/site/minimoogwiki/home/notes)
- [Más de Minimoog](http://www.emusic-diy.org/MoogManuals#head-d983034898c0e3ee8d2f85af3aef51ebb66d2744)
- [Más esquemas de Minimoog](http://www.fantasyjackpalance.com/fjp/sound/synth/synthdata/16-moog-minimoog.html)
- [Otro clone de Minimoog](https://661.org/proj/minimoog/)
- [emusic-diy](http://emusic-diy.org/Schematics): Esquemas variados
- [How to Design and Build an Analog Synthesizer from Scracht](https://www.jiisuki.net/reports/howto-build-analog-synth.pdf) Un pdf
- [Minimo Synth](https://minimosynth.com/) Otro synth, pero digital
- [El canal de Ray Wilson en SoundCloud](https://soundcloud.com/raywilson)
- [Electrocumbia en SoundCloud](https://soundcloud.com/drdubastein/electrocumbia)
- [Obras usando el Noise Toaster en SoundCloud](https://soundcloud.com/search?q=noise+toaster)
- [Mateo Mena y sus Hypercubes](https://invidious.esmailelbob.xyz/watch?v=m55dfTXIUgY)
- [Explicación de distintos tipos de jack](https://media.digikey.com/pdf/Application%20Notes/CUI%20Application%20Notes/Audio_Jack_Switches_Schematics.pdf) (es un pdf [aquí](https://www.cuidevices.com/blog/understanding-audio-jack-switches-and-schematics) lo tienen online)




## Software

### Puredata

En Linux Mint se puede instalar _Puredata_ desde los repos, la versión 0.50.2 en el momento de escribir esto:

```bash
sudo apt install puredata multimedia-puredata

apt search ^pd-     # para ver todas las bibliotecas de puredata disponibles para instalación
```

Si queremos tener una versión más actualizada podemos recurrir al ppa oficial:

```bash
sudo add-apt-repository ppa:pure-data/pure-data
sudo apt update
sudo apt install puredata
```

#### ELSE: Una biblioteca muy completa que incluye un tutorial de pd

Una vez instalada (y probada) la versión 0.52 de Puredata podemos instalar _Else_ desde el menú `Help::Find Externals`, buscamos `else` e instalamos (le va a llevar un ratito, al menos con mi wifi)

Una vez instalada, tenemos que mover el directorio `live-electronics-folder` que contiene el tutorial a un sitio más adecuado (casi seguro que `~/Documents/Pd` si has seguido las sugerencias durante la instalación). Es preferible dejar el directorio `~/Documents/Pd/externals` para las bibliotecas externas.

Con eso ya tenemos el tutorial disponible, no tenemos más que abrir los ficheros del tutorial desde el propio _Puredata_.

#### Referencias

- [Colección de recursos](https://puredata.info/docs/tutorials/)
- [Programming Electronic Music in Pd](http://www.pd-tutorial.com/english/index.html) de Johannes Kreidler (online)
- [Programando Música Electrónica en Pd](https://lucarda.com.ar/pd-tutorial/index.html) traducción del anterior al castellano (online)
- [The Theory and Technique of Electronic Music](http://msp.ucsd.edu/techniques.htm) de Miller Puckette
- [Live Electronics Tutorial](https://github.com/porres/Live-Electronics-Tutorial/blob/v1.0-rc2/README.md) Este tiene muy buena pinta, pero necesitas tener como mínimo la versión 0.52 de puredata, viene incluido como curso introductorio al instalar ELSE en Puredata.
- [Crear un Synth con Puredata](https://linuxaudio.github.io/libremusicproduction/html/tutorials/creating-simple-synthesizer-pure-data-%E2%80%93-part-i.html)
- [Casper Electronics DIY Synth](https://www.youtube.com/watch?v=FaoJaLmZaL4)
- <https://www.instructables.com/Elements-Little-Synths-With-Big-Sounds-1/>
- <https://drive.google.com/drive/folders/1yG68dSTKySPuuXvIyOB6vzyYmIeTKCn1>
- <https://syntherjack.net/category/article/>


### Supercollider

- [Supercollider](https://supercollider.github.io/) en github.


## Podcast

Vamos a proponer una serie de programas centrados en la música electrónica y sintetizadores analógicos, animando a los que quieran unirse a nosotros en la exploración de este tema e incluso construir algún prototipo con la información disponible.

¿Qué tiene que ver este tema con el hw libre? ¿o con esta sección?

Bueno, por un lado la electrónica analógica es un camino interesante para introducirse en el mundillo. La electrónica analógica te permite obtener resultados _inmediatos_ en el sentido de que te ahorras la fase de programar un firmware. Si además puedes disponer de alguna herramienta para visualizar las señales (un osciloscopio) puedes aprender rápidamente un montón de conceptos que llevaría horas explicar usando sólo la teoría.

Por otro lado, cuando empezamos a investigar la documentación disponible vimos que aunque los sintetizadores analógicos son una tecnología "antigua", que precede en una o dos décadas a toda la revolución de la electrónica digital posterior. El espíritu de muchos (no todos, claro) de los pioneros en la música electrónica es fácil de indentificar con el espíritu del hardware libre en la actualidad. Por ejemplo Ray Wilson (1956-2016) en su página MFOS (una referencia imprescindible) siempre se nego a que sus diseños fuera open source pero:

Ray was happy to share his circuit designs and knowledge with hobbyists but did not give permission to mass or hand produce what he considered his intellectual property. (MFOS designs are now owned by synthCube).

Es decir que compartió sus diseños siempre que fueran para uso No Comercial.

Esta filosofía de compartir conocimientos puede verse en las antiguas páginas web y foros que en muchos casos ya sólo están disponibles en [archive.org](https://archive.org/). Se puede comprobar que los constructores de "Sintes" compartían libremente la información y colaboraban para corregir los fallos y mejorar los diseños.

## Rollos sueltos

Una busqueda en Freetube por "eurorack diy" parece arrojar resultado interesantes.
