---
weight: 4
title: "Multímetro Aneng 8009"
date: 2023-11-06T14:04:14+0100
draft: true
summary: "Manual de Usuario del polímetro ANENG8009"
categories:
  - pildoras
tags:
  - intrumentación
---

## Polímetro Aneng 8009

{{< admonition type=abstract title="Referencias" open=true >}}

- <https://www.hestore.hu/prod_getfile.php?id=10353>
- <https://imgur.com/gallery/omQ0tp4>
- <https://es.scribd.com/document/457189964/Aneng-an-8009-User-Manual>
- <https://ssdielect.com/multimetros-y-medidores-1/2196-an8009.html>

{{< /admonition >}}



AN8009 True-RMS: Multímetro Digital de Rango Automático, NCV, Ohmiómetro, AC / DC Voltaje y Corriente, Medición de Temperatura P20

ANENG AN8009 es uno de los primeros multímetros digitales con rango automático de 9999 unidades.

Este producto funciona con batería con rms verdadero, pantalla LED y luz de fondo.

Portátil y fácil de usar.

### CARACTERISTICAS:

- La luz de fondo puede hacer que la pantalla sea fácil de leer en condiciones oscuras.
- De tamaño pequeño, portátil con una bolsa, puede llevarlo a cualquier lugar que lo necesite.
- Fácil de trabajar, el rango automático mide de forma precisa con el chip de autocalibración para garantizar la precisión y la estabilidad.
- ESPECIFICACIONES TECNICAS:
    - Nombre de la marca: ANENG
    - Número de modelo: AN8009
    - Temperatura de funcionamiento: 0 - 40 °
    - Humedad de funcionamiento: =75% RH
    - Condición de almacenamiento: -20 ~ 60 °
    - Humedad de almacenamiento: =80% RH
    - Suministros de bricolaje: eléctricos
    - Modo de funcionamiento: rango automático / manual
    - Rango de medición de la inductancia: no
    - Rango de temperatura de medición: -20 ~ 1000 C / -4F-1832F
    - Rango de capacidad de medición: 9.99nF / 99.99nF / 999.9nF / 9.99uF / 99.99uF / 999.9uF / 9.999MF
    - Rango de voltaje de medición: 999.9mV / 9.999V / 99.99V / 999.9V
    - Rango de corriente de medición: 60mA / 600mA / 10A
    - Rango de resistencia de medición: 99.99 / 999.9 / 9.999k / 99.99k / 999.9K / 999.9M
    - Frecuencia: 99.99Hz / 999.9Hz / 9.999KHz / 99.99KHz / 999.9KHz / 9.999MHz
    - Voltaje DC / AC (mV): 9.999mV / 99.99mV
    - Voltaje DC / AC (V): 999.9mV / 9.999V / 99.99V / 750ACV (999.9DCV)
    - Corriente DC / AC (mA & A): 999.9mA / 9.999A
    - Corriente DC / AC (uA): 99.99µA / 999.9µA
    - Tipo de pantalla: Pantalla digital
    - Prueba de diodo: si
    - Continuidad: si
    - Ciclo de trabajo: 1% -99%
    - Frecuencia de muestreo: 3 veces por segundo
    - Potencia: 2 * 1.5V pilas AAA (no incluidas)

- Contenido del Paquete:
    - 1 x multímetro
    - 1 x cable de prueba + sensor de temperatura
    - 1 x manual de usuario
    - 1 x bolsa de almacenamiento
    - 1 x 16pc sonda de prueba

Advertencia:

1. NO exceda el “valor máximo” indicado en la Especificación;

2. NO ingrese voltaje en el modo actual, el modo de resistencia, el modo de diodo, el modo de continuidad o el modo de temperatura;

3. NO use el producto cuando las baterías o la tapa de la batería no estén colocadas correctamente;

4. Apague el producto y retire los cables de prueba de los puntos de prueba antes de cambiar las baterías o los fusibles.

5.Do no excede la tensión de entrada de 36V CC o 25V AC cuando está en el ajuste de la corriente de medición.

Referencia de producto: AN8009



### Botones

#### Range/Backlight

Al presionar este botón entramos en los rangos manuales, cada presión en el botón aumenta el rango, al llegar al mayor rango la siguiente presión del botón te lleva al menor. Para salir del rango manual hay que mover el selector rotativo de función.
Si presionamos el botón continuamente más de 2 segundos encendemos la luz de la pantalla.

#### Select/Hold

Permite seleccionar entre distintos modos de funcionamiento dependiendo de la posición del selector rotativo de función. Si presionamos el bótón mas de 2 segundos entramos en el modo ___Hold___.

#### Selector de función

Posiciones

| Pos. | Significado        |
|:-----|:-------------------|
| Off  | Polímetro apagado  |
| DC V | Voltajes en DC y AC, Frecuencia (alto voltaje y baja frecuencia), Ciclo de trabajo  |
| mV   | Voltajes en DC y AC en el orden de milivoltios, Temperatura,   |
| 100M | Resistencia, Continuidad, Diodo y Capacidad   |
| Hz   | Frecuencia (bajo voltaje y alta frecuencia), Ciclo de trabajo  |
| A    | Medidas de intensidad en DC y AC  |
| µA   | Medidas de intensidad en DC y AC en el orden de micro amperios  |
| NCV  | Detección de cables con AC |


### Medidas de voltaje AC y DC

1. Conecta las puntas de prueba en las posiciones correspondientes (comun y conector derecho)
2. Selecciona la función de medida de voltajes en el selector rotativo
3. Selecciona AC o DC en el botón __Sel__
4. Procede con las medidas

### Medidas de corriente AC y DC

1. Conecta las puntas de prueba en las posiciones correspondientes: Negra en `COM` y roja en `A mA` (centro e izquierda respectivamente)
2. Selecciona la función de medida de intensidades en el selector rotativo (posición `A mA`)
3. Selecciona AC o DC en el botón `Sel`
4. El medidor tiene que estar conectado en serie, tendrás que abrir el circuito donde quieres hacer la medida y poner el medidor en el medio.

__Mucho ojo con respetar las especificaciones y los rangos de funcionamiento del polímetro__

### Medidas de corriente AC y DC (rango de micro amperios)

### Medidas de resistencia

### Medida de continuidad

### Comprobar diodos

### Medir Capacidad

### Medidas de frecuencia y ciclo de trabajo

### Medida de temperatura

### Medidas de NCV

### Auto-apagado

El medidor se apaga a los quince minutos de inactividad. Pitará cinco minutos antes de apagarse para avisar. Puedes cancelar el apagado pulsando el botón __Sel__. Puedes cancelar el apagado automático si mantienes pulsado el botón __Sel__ mientras lo enciendes, pitará cinco veces para avisar de la cancelación.
